#include "StdAfx.h"
#include "AgentMapGenerator.h"

#include "Scoala.h"

#include <assert.h>
#include <ctime>
#include <fstream>
#include <iostream>
#include <sstream>
#include <stdio.h>

AgentMapGenerator::~AgentMapGenerator(void)
{
}

bool AgentMapGenerator::perform()
{
  if (_generate == 1)
    return randomGenerate();
  else 
    return readGenerated();
};


bool AgentMapGenerator::readGenerated()
{
  std::ifstream mapStream;
  mapStream.open(_mapFileName.c_str());
  
  //FILE *f;
  //f = fopen(_mapFileName.c_str(), "r");
  //f = fopen("testinput.txt", "r");
  int i = 0;
  int j = 0;
  int numberFree = 0;
  
  for (i=0;i<N && !mapStream.eof();i++)
  {
    
    //char line[350];
    //fgets(line,sizeof(line),f);
    std::string fileLine;
    std::getline(mapStream,fileLine);
    std::istringstream stream(fileLine); 
    for (j =0; j<N; j++)
    {
      int agentType;
      stream >> agentType;
      _ag[i][j].tipul_agentului = agentType;
      
      switch(agentType)
      {
      case -1 :
        _numberBlacks++;
        break;
      case 1:
        _numberWhites++;
        break;
      case 5:
        {
          _ag[i][j].x_pos = i;
          _ag[i][j].y_pos = j;
          Scoala scoala;
          scoala.x_pos = i;
          scoala.y_pos = j;
          _vectorScoli.push_back(scoala);
        };
         _numberSchools++;
        break;
      case 0:
        numberFree++;
        break;
      default:
        assert(false);
      };
      
    }
  };

  if (i == N && j == N) 
  {
    assert(numberFree + _numberBlacks + _numberSchools + _numberWhites == N*N);
    mapStream.close();
    return true;
  }

  mapStream.close();
  return false;
};


bool AgentMapGenerator::randomGenerate()
{
  // school generation
  SchoolsGenerator scGen(_voronoiFileName.c_str());
  if(!scGen.generate()) 
    return false;
  _vectorScoli = scGen.getSchools();
  _numberSchools = scGen.getNumberOfSchools();

  if (N*N< _numberBlacks + _numberSchools + _numberWhites) 
	{   
		std::cout << "The data introduced is invalid" << std::endl << "Please check data" << std::endl;
    std::cout << "The world cannot hold " << _numberBlacks << "blacks, " << _numberWhites << "whites and "<< _numberSchools << "schools" <<std::endl;
    return false;
	};


  for (size_t i=0; i<_vectorScoli.size(); i++)
  {
    const int xPoz = _vectorScoli[i].x_pos;
    const int yPoz = _vectorScoli[i].y_pos;
    _ag[xPoz][yPoz].tipul_agentului = Agent::School;
    _ag[xPoz][yPoz].x_pos = xPoz;
    _ag[xPoz][yPoz].y_pos = yPoz;
  }


  // generating A group agents
  srand(time(0));
  int i=0;
  while ( i<_numberWhites )
	{
		int x0 = rand()%N;
		int y0 = rand()%N;
		 
		if ( _ag[x0][y0].tipul_agentului == Agent::Free)
		{
      _ag[x0][y0].tipul_agentului = Agent::White;
			i++;
		};
	};

	//generating B group agents
	i=0;
  while ( i<_numberBlacks)
	{
		int x0 = rand()%100;
		int y0 = rand()%100;
		 
    if ( _ag[x0][y0].tipul_agentului == Agent::Free)
		{
      _ag[x0][y0].tipul_agentului = Agent::Black;
			i++;
		};
	}


  return true;

};
