#pragma once
#include <iostream>
#include <string>

#include "Agent.h"
#include "Scoala.h"


#define N 100

typedef Agent AgentMap[N][N];

class AgentMapGenerator
{
public:
  AgentMapGenerator(char* mapFileName): _mapFileName(mapFileName) 
  {
    _generate = 0;
    _numberWhites = 0;
    _numberBlacks = 0;
    _numberSchools = 0;
    _voronoiFileName ="";
    for (int j=0;j<N;j++)
      for(int l=0;l<N;l++)
      {
        _ag[j][l].tipul_agentului = Agent::Free;
        _ag[j][l].x_pos = j;
        _ag[j][l].y_pos = l;
      }
  };
  
  AgentMapGenerator(int nrWhites, int nrBlacks, char* voronoiFileName): 
  _numberWhites(nrWhites), 
    _numberBlacks(nrBlacks),
    _numberSchools(0),
    _voronoiFileName(voronoiFileName) 
  {
      _generate = 1;
      _mapFileName = "";
      for (int j=0;j<N;j++)
        for(int l=0;l<N;l++)
        {
          _ag[j][l].tipul_agentului = Agent::Free;
          _ag[j][l].x_pos = j;
          _ag[j][l].y_pos = l;
        }
  };


  bool perform();
  ~AgentMapGenerator(void);
  Scoli getScoli() { return _vectorScoli;} ;
  int getNumberWhites() {return _numberWhites;};
  int getNumberBlacks() {return _numberBlacks;};
  int getNumberSchools() {return _numberSchools;};


  AgentMap _ag;
private:
  int _generate;
  int _numberWhites;
  int _numberBlacks;
  int _numberSchools;
  std::string _mapFileName;
  std::string _voronoiFileName;
  Scoli  _vectorScoli;

  bool randomGenerate();
  bool readGenerated();
};

