#include "stdafx.h"
#include <iostream>
#include <iomanip> 
#include <stdio.h>
#include <vector>
#include <string>
#include "intarray2bmp.h"
#include "cartier.h"
#include "AgentMapGenerator.h"

const int myN=100;

void cartier::compute_cartier()
{
	for (unsigned int k=0; k<sc.size(); k++)
	{
		sc[k].cartier.clear();
	}

	for (int i =0; i<N; i++)
		for (int j=0; j<N; j++)
		{
			coord poz;
			poz.x_pos = i;
			poz.y_pos = j;

			double dist = 4.*N;
			int cart = -1;
			for (int k=0; k<sc.size(); k++)
			{
				double d = dist_tor(i,j,sc[k].x_pos, sc[k].y_pos,myN);
				if (d < dist) {
					cart = k;
					dist = d;
				}
			}
			if (cart >= 0 && cart < sc.size()&& dist>0) 
			{
				sc[cart].cartier.push_back(poz);
				ag[i][j].scoala = cart;
			}
      else 
      {
        cart = 1;
      }

		}

		for(int i =0; i<sc.size(); i++)
			sc[i].nr_maxim_studenti = sc[i].cartier.size();
}

cartier::cartier(char *_voronoiFile, char *agentsFile)
{
	FILE *f; //entry file
	char s[256];

	f = fopen(agentsFile,"r");
	if (f == NULL) 
	{
		cout << "Input file = " << agentsFile << " could not be found" <<endl;
	}
	
   // reading generation method
  fgets(s,256,f);
	fgets(s,256,f); sscanf_s(s,"%d",&generate);

	if (generate == 1) 
  {
    // reading number of agents
    fgets(s,256,f);
    fgets(s,256,f); sscanf_s(s,"%d%d",&nr_agenti, &nr_agenti_albi);
  }
  else
  {
    // reading name of the input file
    fgets(s,256,f);
    fgets(s,256,f); sscanf_s(s,"%s",&inputFileName, sizeof(inputFileName));
  };


	fgets(s,256,f);
  fgets(s,256,f);	sscanf_s(s,"%d%s",&exportToFile, &outputFileName, sizeof(outputFileName));

	//no of repetitions
	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s,"%d",&nr_repetitii);

	//no of agents considered
	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s,"%d",&nr_agenti_pe_ciclu);

	//no of tries
	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s,"%d",&nr_incercari_pozitii);

	//reading t
	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s,"%lf",&prag_satisfactie);


	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s,"%lf",&radius_moore);


	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s,"%lf",&r);


	//no of runs
	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s, "%d", &statistica);

	//white agent's parameters
	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s, "%lf %lf", &MA, &fA);

	//black agent's parameters
	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s, "%lf %lf", &MB, &fB);

	
	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s, "%lf %lf", &alpha, &dist_max);

	
	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s, "%d", &pas_timp);

	//intervals for printing graphs
	fgets(s, 256, f);
	fgets(s, 256, f);
	sscanf_s(s, "%d", &pas_timp_bmp);

	cout << "Done reading "<<endl;

  AgentMapGenerator agGenerator(nr_agenti_albi,nr_agenti - nr_agenti_albi, _voronoiFile);
  if (generate == 1) 
  {
    agGenerator= AgentMapGenerator(nr_agenti_albi,nr_agenti - nr_agenti_albi, _voronoiFile);
  }
  else
  {
    agGenerator= AgentMapGenerator(inputFileName);
  }
    
    agGenerator.perform();
    sc = agGenerator.getScoli();
    for (int i=0; i<N;i++) 
      for (int j = 0;j<N;j++)
      {
        ag[i][j] = agGenerator._ag[i][j];
      };
    nr_agenti_albi = agGenerator.getNumberWhites();
    nr_agenti = agGenerator.getNumberWhites() + agGenerator.getNumberBlacks();
   
  compute_cartier(); 
	
}

cartier::~cartier()
{
	sc.clear();
	residential_stat.clear();
	school_stat.clear();
	
}

bool cartier::print_bmp(int text)
{
	unsigned char a[5*N][5*N];
	for ( int i = 0; i<5*N; i++)
		for(int j=0; j<5*N ; j++)
		{
			a[i][j] = ag[i/5][j/5].tipul_agentului+2;
		}; 

	char c[256];
	switch(text)
	{
	case 0:
		sprintf_s(c,"original.bmp");
		break;
	case -1:
		sprintf_s(c,"final.bmp");
		break;
	default:
		sprintf_s(c,"stage%05d.bmp",text);
	}
	bool result = intarray2bmp::intarray2bmp <unsigned char> ( c, &(a[0][0]), 5*N, 5*N, 1, 7 );   
	return result;
}

double cartier::indice_segregare_cartier(const int nr_cartier)
{
	int pig = 0; //whites in the negh.
	int pih = 0; // blacks in th enigh.
	if (nr_cartier <0 || nr_cartier>sc.size() ) return -1;

	for (int i=0; i<sc[nr_cartier].cartier.size(); i++)
	{
		coord c;
		c = sc[nr_cartier].cartier[i];
		if (ag[c.x_pos][c.y_pos].tipul_agentului == 1) pig++;
		if (ag[c.x_pos][c.y_pos].tipul_agentului == -1) pih ++;
	}

	if (nr_agenti_albi == 0) return 1;
	if (nr_agenti == nr_agenti_albi) return 1;

	return 0.5*abs((1.*pig)/(nr_agenti_albi) - (1.*pih)/(nr_agenti-nr_agenti_albi));

}
double cartier::indice_segregare_total()
{	
	double sum = 0 ;
	
	for (int i=0; i<sc.size(); i++)
	{
		double d = indice_segregare_cartier(i);
		sum+=d;
	}
	return sum;
}

double cartier::utility_schelling(int tipul_agentului, int x, int y)
{
	int nr_albi=0, nr_negri=0, nr_vecini;
	
	//count no of black and no of white neigh.
	for (int i=-(int)r ;i<=(int)r; i++)
		for (int j=-(int)r; j<=(int)r; j++)
		{
			double d = sqrt(1.*i*i+j*j);
			if (d<=r)
			{
			if ( i!=0 || j!=0 )
				switch (ag[(x+i)%N][(y+j)%N].tipul_agentului) 
				{
					case 1: 
						nr_albi++;
						break;
					case -1:
						nr_negri++;
						break;
				}
			}
		}
	
	return util_schel(tipul_agentului,nr_albi, nr_negri);
}



bool cartier::CountHappyAgentsSchelling(int &group1, int &group2)
{
	group1 = 0;
	group2 = 0;
	for (int i = 0; i<N; i++)
		for (int j = 0; j<N;j++)
		{
			if (utility_schelling(ag[i][j].tipul_agentului, i, j) >= prag_satisfactie )
			{
				if (ag[i][j].tipul_agentului == 1) {
					group1++;
				}
				else if (ag[i][j].tipul_agentului == -1) {
					group2++;
				}
			}
		}
		return true;
}

double cartier::CalculateAverageProportionOwnKind() const
{
	double averageProportions = 0;
	int noAgents = 0;

	for (int x = 0; x<N; x++)
		for (int y = 0; y<N;y++)
		{

			int nr_albi=0, nr_negri=0, nr_vecini = 0;

			//count no of black and no of white neigh.
			for (int i=-(int)r ;i<=(int)r; i++)
				for (int j=-(int)r; j<=(int)r; j++)
				{
					double d = sqrt(1.*i*i+j*j);
					if (d<=r)
					{
            if ( i!=0 || j!=0 )
            {
              const int n = N;
              const int xpos = (x+i+N)%N;
              const int ypos = (y+j+N)%N;
              switch (ag[xpos][ypos].tipul_agentului) 
              {
              case 1: 
                nr_albi++;
                break;
              case -1:
                nr_negri++;
                break;
              }
            }
					}
				}

        nr_vecini = nr_albi+nr_negri;
        if (ag[x][y].tipul_agentului == 1 && nr_vecini>0) {
          averageProportions += (1.*nr_albi)/nr_vecini;
          noAgents++;
        }
        else if (ag[x][y].tipul_agentului == -1 && nr_vecini>0) {
          averageProportions += (1.*nr_negri)/nr_vecini;
          noAgents++;
        }
    }

		return averageProportions/noAgents;
}



bool cartier::CountHappyAgentsSchools(int &group1, int &group2)
{
	group1 = 0;
	group2 = 0;
	for (int i = 0; i<N; i++)
		for (int j = 0; j<N;j++)
		{
			if (ag[i][j].tipul_agentului == 1) {
				if (utility_school(i,j,ag[i][j].scoala) >= prag_satisfactie )
					group1++;
			}
			else if (ag[i][j].tipul_agentului == -1) {
				if (utility_school(i,j,ag[i][j].scoala) >= prag_satisfactie )
					group2++;
			}
		}
	return true;
}

double cartier::CountProportionOutsideRange() const 
{
	const double lowerRangeWhite = fA*prag_satisfactie;
	const double upperRangeWhite= 1- fB*prag_satisfactie;

	int numberAgentsOutsideRange = 0;

	double averageProportions = 0;
	int noAgents = 0;

	for (int x = 0; x<N; x++)
		for (int y = 0; y<N;y++)
		{

			int nr_albi=0, nr_negri=0, nr_vecini = 0;

			//count no of black and no of white neigh.
			for (int i=-(int)r ;i<=(int)r; i++)
				for (int j=-(int)r; j<=(int)r; j++)
				{
					double d = sqrt(1.*i*i+j*j);
					if (d<=r)
					{
						if ( i!=0 || j!=0 )
						{
							const int n = N;
							const int xpos = (x+i+N)%myN;
							const int ypos = (y+j+N)%myN;
							switch (ag[xpos][ypos].tipul_agentului) 
							{
							case 1: 
								nr_albi++;
								break;
							case -1:
								nr_negri++;
								break;
							}
						}
					}
				}

				nr_vecini = nr_albi+nr_negri;

				if (nr_vecini>0) 
				{
					if (ag[x][y].tipul_agentului == -1 || ag[x][y].tipul_agentului == 1) 
						//if (ag[x][y].tipul_agentului == 0)
					{

						const double proportionWhites = (1.*nr_albi)/nr_vecini;
						if (proportionWhites < lowerRangeWhite || proportionWhites > upperRangeWhite)
							numberAgentsOutsideRange++;

					}
				}

		}

		const double rez =(1.*numberAgentsOutsideRange)/nr_agenti;
		return rez;
}

void cartier::schelling(char *c2)
{
	// determine available locations and ocuppied locations
	vector<coord> pozitii_libere, pozitii_ocupate;
	int i;

	for (i=0;i<N;i++)
		for (int j=0;j<N;j++)
		{   
			coord poz;
			poz.x_pos = i;
			poz.y_pos = j;
			
			switch (ag[i][j].tipul_agentului )
			{
			case 0:	
				pozitii_libere.push_back(poz);
				break;
			case -1:
			case  1: 
				pozitii_ocupate.push_back(poz);
				break;
			};
				
		};

	srand(time(0)); 

	FILE *f=fopen(c2,"w");
	fprintf(f, "pas_timp indice_segregare indice_segregare_moore indice_segregare_raza HappyWhiteAgents HappyBlackAgents\n");

	vector<coord> agenti_de_mutat;
	vector<coord> destinatii_agenti;
	residential_stat.clear();
	evolution temp;
	temp.pas = 0;
	temp.value = indice_segregare_total();
	int HappyWhites, HappyBlacks;
	CountHappyAgentsSchelling(HappyWhites,HappyBlacks);
	
	cout << "CalculateAverageProportionOwnKind():"<<CalculateAverageProportionOwnKind() << endl;
  cout << "CountProportionOutsideRange()      :"<<CountProportionOutsideRange() << endl;
		
	residential_stat.push_back(temp);
	fprintf(f, "%10d %10.7lf %10.7lf %10.7lf %5d %5d\n", 0,temp.value, indice_segregare_moore_total(1.5), indice_segregare_moore_total(radius_moore), HappyWhites, HappyBlacks);
	for(i=1;i<=nr_repetitii;i++)
	{
		
		for (int kk =0; kk < nr_agenti_pe_ciclu; kk++)
		{
			
			int nr_agent_de_mutat = rand()%pozitii_ocupate.size();
		
			coord sursa;
			sursa.x_pos = pozitii_ocupate[nr_agent_de_mutat].x_pos;
			sursa.y_pos = pozitii_ocupate[nr_agent_de_mutat].y_pos;

			int tip_agent = ag[sursa.x_pos][sursa.y_pos].tipul_agentului;
			
		
			if (utility_schelling(tip_agent, sursa.x_pos, sursa.y_pos) < prag_satisfactie) 
			{
				coord dest; 
				int j;
				int nr_pozitia_dest;
				bool done=false;


				for (j = 0; j<nr_incercari_pozitii &&!done; j++) 
				{
					nr_pozitia_dest = rand()%pozitii_libere.size();

					dest.x_pos = pozitii_libere[nr_pozitia_dest].x_pos;
					dest.y_pos = pozitii_libere[nr_pozitia_dest].y_pos;

					if ( utility_schelling (tip_agent, dest.x_pos, dest.y_pos) >= prag_satisfactie)
					{
						
						agenti_de_mutat.push_back(sursa);
						
						destinatii_agenti.push_back(dest);
						
						pozitii_ocupate.erase( pozitii_ocupate.begin()+nr_agent_de_mutat);
						
						pozitii_libere.erase( pozitii_libere.begin()+nr_pozitia_dest);
						done = true;
						
					};
				};

				double ref = utility_schelling(tip_agent, sursa.x_pos, sursa.y_pos);
			
				for (j = 0; j<nr_incercari_pozitii &&!done; j++) 
				{
					nr_pozitia_dest = rand()%pozitii_libere.size();

					dest.x_pos = pozitii_libere[nr_pozitia_dest].x_pos;
					dest.y_pos = pozitii_libere[nr_pozitia_dest].y_pos;

					if ( utility_schelling (tip_agent, dest.x_pos, dest.y_pos) >=ref)
					{
						
						agenti_de_mutat.push_back(sursa);
						
						destinatii_agenti.push_back(dest);
						
						pozitii_ocupate.erase( pozitii_ocupate.begin()+nr_agent_de_mutat);
						
						pozitii_libere.erase( pozitii_libere.begin()+nr_pozitia_dest);
						done = true;
						
					}
				}
				
			} 
		};

		
		for (int k = 0; k< destinatii_agenti.size(); k++)
		{
			ag[destinatii_agenti[k].x_pos][destinatii_agenti[k].y_pos].tipul_agentului = ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].tipul_agentului;
			ag[destinatii_agenti[k].x_pos][destinatii_agenti[k].y_pos].scoala = ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].scoala;

			ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].tipul_agentului = 0;
			ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].scoala = -1;

			pozitii_libere.push_back(agenti_de_mutat[k]);
			pozitii_ocupate.push_back(destinatii_agenti[k]);
		};

		if(i%pas_timp==0) 
		{	
			temp.pas = i;
			temp.value = indice_segregare_total();
			CountHappyAgentsSchelling(HappyWhites, HappyBlacks);
			fprintf(f, "%10d %10.7lf %10.7lf %10.7lf %5d %5d\n", i,temp.value, indice_segregare_moore_total(1.5), indice_segregare_moore_total(radius_moore), HappyWhites, HappyBlacks);
			residential_stat.push_back(temp);
		}

		// cout <<"i=" <<i<< "CalculateAverageProportionOwnKind()"<<CalculateAverageProportionOwnKind()<<endl;
	
		if(i%pas_timp_bmp==0) 
		{
				print_bmp(i);
				cout<< "pas = "<<i <<endl;
		}
		
		//cout << "agenti_de_mutat.size" << agenti_de_mutat.size()<<endl;
		//cout << "dest_agenti.size" << destinatii_agenti.size()<<endl;
		//cout << "pozitii_libere.size" <<pozitii_libere.size() <<endl <<endl;
		//cout << "prag_satisfactie " << prag_satisfactie<<endl;
		
		agenti_de_mutat.clear();
		destinatii_agenti.clear();
		
	}

  cout << "CalculateAverageProportionOwnKind():"<<CalculateAverageProportionOwnKind() << endl;
  cout << "CountProportionOutsideRange()      :"<<CountProportionOutsideRange() << endl;
	
	fclose(f);


}
void cartier::initializare_scoli()
{
	
	for( int i = 0; i< sc.size(); i++)
	{
		sc[i].nr_studenti = 0;
		sc[i].nr_albi = 0;
		
		for( int j = 0; j<sc[i].cartier.size(); j++)
		{
			switch(ag[sc[i].cartier[j].x_pos][sc[i].cartier[j].y_pos].tipul_agentului)
			{
			case -1:  
				ag[sc[i].cartier[j].x_pos][sc[i].cartier[j].y_pos].scoala = i;
				sc[i].nr_studenti++;
				break;
			case 1:
				ag[sc[i].cartier[j].x_pos][sc[i].cartier[j].y_pos].scoala = i;
				sc[i].nr_studenti++;
				sc[i].nr_albi++;
				break;
			}
		}

	}
		

}
double cartier::utility_school(const int poz_x, const int poz_y, const int nr_scoala)
{
	if (nr_scoala < 0 ||nr_scoala >sc.size()) return 0;
	int nr_negri = sc[nr_scoala].nr_studenti - sc[nr_scoala].nr_albi;
	int tipul_agentului = ag[poz_x][poz_y].tipul_agentului;
	double dist = dist_tor(poz_x, poz_y, sc[nr_scoala].x_pos, sc[nr_scoala].y_pos,N);

	return util_m2(tipul_agentului, sc[nr_scoala].nr_albi,nr_negri,dist);	
}

double cartier::indice_segregare_scoli()
{
	double d= 0;
	for ( int i=0; i<sc.size(); i++)
	{
		d+= 0.5*abs((1.*sc[i].nr_albi)/(nr_agenti_albi) - (1.*(sc[i].nr_studenti - sc[i].nr_albi))/(nr_agenti-nr_agenti_albi));
	}
	return d;
}
double cartier::indice_segregare_scoala(const int nr_scoala)
{
	double d= 0;
	if (nr_scoala <0 || nr_scoala>sc.size() ) return -1;
	int i = nr_scoala;
	d+= 0.5*abs((1.*sc[i].nr_albi)/(nr_agenti_albi) - (1.*(sc[i].nr_studenti - sc[i].nr_albi))/(nr_agenti-nr_agenti_albi));
	return d;
}
void cartier::segregare_scoli(char *c2)
{
	vector<coord> pozitii_ocupate;
	int i,j;
	int HappyWhiteStudents, HappyBlackStudents;
	compute_cartier();

	for (i=0;i<N;i++)
		for (j=0;j<N;j++)
		{   
			coord poz;
			poz.x_pos = i;
			poz.y_pos = j;
			
			switch (ag[i][j].tipul_agentului )
			{
			case 0:
				break;
			case 5:
				break;
			case -1:
				pozitii_ocupate.push_back(poz);
				break;
			case  1: 
				pozitii_ocupate.push_back(poz);
				break;
			};
				
		};

	cout<<pozitii_ocupate.size()<<"....";

	for (i =0; i<sc.size(); i++)
	{
		int elevi = 0;
		int elevi_albi=0;
		for (j=0; j<sc[i].cartier.size(); j++)
		{
			coord s = sc[i].cartier[j];
			if (ag[s.x_pos][s.y_pos].tipul_agentului == 1 || ag[s.x_pos][s.y_pos].tipul_agentului == -1) elevi++;
			if (ag[s.x_pos][s.y_pos].tipul_agentului == 1 ) elevi_albi++;
		}
		sc[i].nr_studenti = elevi;
		sc[i].nr_albi = elevi_albi;
	}

	FILE *f=fopen(c2,"w");
	fprintf(f, "pas_timp indice_segregare HappyWhiteStudents HappyBlackStudents\n");
	vector<coord> agenti_de_mutat;
	vector<int> scoala_destinatie;

	vector<int> locuri_libere;
	locuri_libere.resize(sc.size(),0);

	school_stat.clear();
	evolution temp;
	temp.pas = 0;
	temp.value = indice_segregare_scoli();
	school_stat.push_back(temp);
	CountHappyAgentsSchools(HappyWhiteStudents, HappyBlackStudents);

	fprintf(f, "%10d %10.7lf %5d %5d\n", 0,temp.value, HappyWhiteStudents, HappyBlackStudents);

	for(i=1;i<=nr_repetitii;i++)
	{
		//cout << "i=" << i << endl; 
		for(j=0;j<sc.size(); j++)
		{
			locuri_libere[j] = sc[j].nr_maxim_studenti - sc[j].nr_studenti; 
			//cout << sc[j].nr_maxim_studenti<<" "<< locuri_libere[j] << "  "; 
		}
		
		for (int k =0; k < nr_agenti_pe_ciclu; k++)
		{
			int nr_agent_de_mutat = rand()%pozitii_ocupate.size();
			coord sursa;
			
			sursa.x_pos = pozitii_ocupate[nr_agent_de_mutat].x_pos;
			sursa.y_pos = pozitii_ocupate[nr_agent_de_mutat].y_pos;
			
			//	cout<<"Aici"<<pozitii_ocupate.size()<<" "<<k<<" " <<nr_agent_de_mutat<<" "<< tip_agent
			//	<< "  " << ag[sursa.x_pos][sursa.y_pos].scoala<< " "
			//	<< "("<< sursa.x_pos<<","<< sursa.y_pos<<")"<<endl;
			double ref = utility_school(sursa.x_pos, sursa.y_pos, ag[sursa.x_pos][sursa.y_pos].scoala);
			
			if ( ref < prag_satisfactie) 
			{
				//cout << "k=" << k <<"ref="<<ref<<"("<< sursa.x_pos <<","<< sursa.y_pos<< ")"<<
				//	tip_agent << "  "<<ag[sursa.x_pos][sursa.y_pos].scoala <<"\n\n"; 
				vector<int> rand_sc;
				
				for(j = 0; j<sc.size(); j++)
				{
					if(locuri_libere[j]>0) rand_sc.push_back(j);
				}

				bool done = false;		
				while(rand_sc.size()>0 && !done)
				{   
					int nr_sc_test;
					nr_sc_test=rand()%rand_sc.size();
					j = rand_sc[nr_sc_test];

					if(locuri_libere[j] > 0 && utility_school(sursa.x_pos,sursa.y_pos, j) > prag_satisfactie )
					{
						done = true;
						agenti_de_mutat.push_back(sursa);
						scoala_destinatie.push_back(j);
						locuri_libere[j]--;
					}
					rand_sc.erase(rand_sc.begin()+nr_sc_test);
				}

				rand_sc.clear();
				for(j = 0; j<sc.size() && !done; j++)
				{
					if(locuri_libere[j]>0) rand_sc.push_back(j);
				}

				while(rand_sc.size()>0 && !done)
				{   
					int nr_sc_test;
					nr_sc_test=rand()%rand_sc.size();
					j = rand_sc[nr_sc_test];
					
					if(utility_school(sursa.x_pos,sursa.y_pos, j) > ref && locuri_libere[j] > 0)
					{
						done = true;
						agenti_de_mutat.push_back(sursa);
						scoala_destinatie.push_back(j);
						locuri_libere[j]--;
					}
					rand_sc.erase(rand_sc.begin()+nr_sc_test);
				}

				//cout <<"i="<<i <<" j="<< j << " done = " << done <<endl;

			} 
	//		cout<<"Aici"<<pozitii_ocupate.size()<<" "<<k<<endl;
			
		};

		// end of a cycle 
		// moving and actualizing the lists of agents

		for (int k = 0; k< agenti_de_mutat.size(); k++)
		{
		    // cout << ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].scoala <<endl;
			sc[ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].scoala].nr_studenti --;
			if(ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].tipul_agentului == 1)
			{
				sc[ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].scoala].nr_albi--;
			}
			
			ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].scoala = scoala_destinatie[k];
			
			sc[ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].scoala].nr_studenti ++;
			if(ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].tipul_agentului == 1)
			{
				sc[ag[agenti_de_mutat[k].x_pos][agenti_de_mutat[k].y_pos].scoala].nr_albi++;
			}

		};
	 //	printf("aici\n\n");
		agenti_de_mutat.clear();
		scoala_destinatie.clear();

		
		if(i%pas_timp==0)
		{
			evolution temp;
			temp.pas = i;
			temp.value = indice_segregare_scoli();
			school_stat.push_back(temp);

			CountHappyAgentsSchools(HappyWhiteStudents, HappyBlackStudents);
			fprintf(f, "%10d %10.7lf %5d %5d\n", i,temp.value, HappyWhiteStudents, HappyBlackStudents);
		}

		agenti_de_mutat.clear();
		
	}
	
	fclose(f);
	f=fopen("indice_segregare_scoli.txt","w");
	fprintf(f, "no_school segregation coordX coordY no_students no_popA size_sch procalbi/sc\n");
	for(int i=0;i<sc.size();i++)
	{
		double d= indice_segregare_scoala(i);
		fprintf(f,"%3d %10.7lf %3d %3d %4d %4d %5d %10.7lf \n", i+1, d, sc[i].x_pos, sc[i].y_pos, sc[i].nr_studenti, sc[i].nr_albi, sc[i].nr_maxim_studenti, (1.*sc[i].nr_albi)/sc[i].nr_studenti);

	}

	fclose(f);

}


double cartier::indice_segregare_moore(const int x, const int y, double range )
{
	int idxVeciniAlbi = 0, idxVeciniNegri = 0;
	if (range <= 0) return -1;

	// @obs: The Agent is part of his neighbourhood.
	int idx_sum = 0;
	for (int i = -(int)range; i<= (int)range; i++)
		for ( int j = - (int)range; j<= (int)range; j++)
		{
			if (i*i + j*j <= range*range) 
			{
				idx_sum++;
				if (ag[(x+i)%N][(y+j)%N].tipul_agentului == 1) idxVeciniAlbi++;
				else if (ag[(x+i)%N][(y+j)%N].tipul_agentului == -1) idxVeciniNegri++;
			};
		};

	if (nr_agenti_albi == 0) return 1;
	if (nr_agenti == nr_agenti_albi) return 1;

	if (idx_sum ==0 )  
		return 0.5*abs((1.*idxVeciniAlbi)/(nr_agenti_albi) - (1.*idxVeciniNegri)/(nr_agenti-nr_agenti_albi));
	else 
	return 0.5*abs((1.*idxVeciniAlbi)/(nr_agenti_albi) - (1.*idxVeciniNegri)/(nr_agenti-nr_agenti_albi))/ idx_sum;
}

double cartier::indice_segregare_moore_total(double range)
{
	double Sum = 0.;
	for (int i = 0; i<N; i++)
		for (int j = 0; j<N;j++)
		{
			//if (ag[i][j].tipul_agentului == 1 || ag[i][j].tipul_agentului == -1) 
			//{
				Sum +=indice_segregare_moore(i,j, range);
			//}
		};
	
	return Sum;
}


void cartier::EportMapToOutputFile(void)
{
  if (exportToFile != 1)
    return;    

  fstream mapStream;
  mapStream.open(outputFileName,std::ios::out);

  for (int i = 0; i <N; i++)
  {
    for ( int j= 0; j<N; j++)
    {
      mapStream << std::setw(3) << ag[i][j].tipul_agentului << " ";
    };

    mapStream<<endl;
  }

  mapStream.close();
}