#include <iostream>
#include <stdio.h>
#include <vector>
#include <ctime>
#include <string>
#include "intarray2bmp.h"
#include "utility.h"
#include "Agent.h"
#include "AgentMapGenerator.h"
#include "Scoala.h"

#ifndef N
#define N 100
#endif

using namespace std;

//const double r = 1.5;

struct evolution{
	int pas;
	double value;
};
typedef vector<evolution> evArray;


class cartier: public utility
{
public:
	cartier(char *c1 = NULL, char *c2=NULL);
	~cartier();
	bool print_bmp( int text);
	void compute_cartier();
	double indice_segregare_cartier(const int nr_cartier);
	double indice_segregare_total();

	double indice_segregare_moore(const int x, const int y,double range ); // range = 1.5 is the standard value for a moore neighbourhood
	double indice_segregare_moore_total(double range =1. );

	double utility_schelling(int tipul_agentului, int x, int y);
	void schelling(char *c1="segregare_in_time.txt");
	void initializare_scoli();
	double utility_school(const int x, const int y, const int nr_scoala);
	double indice_segregare_scoli();
	double indice_segregare_scoala(const int numar_scoala);
	void segregare_scoli(char *c1 = "segregare_scoli_in_time.txt");
	
	bool CountHappyAgentsSchelling(int &group1, int &group2);
	bool CountHappyAgentsSchools(int &group1, int &group2);
	
  double CalculateAverageProportionOwnKind() const;
  double CountProportionOutsideRange() const;

  void setFA(const double value) { 
    fA = value;
  }
  void setFB(const double value) { 
    fB = value;
  }

  double getRadiusMoore(){
    return radius_moore;
  }

  void EportMapToOutputFile();

public:
	int nr_agenti;
	int nr_agenti_albi, nr_repetitii, nr_agenti_pe_ciclu, statistica, nr_incercari_pozitii;
  char inputFileName[256], outputFileName[256];
	evArray residential_stat, school_stat;
  int generate, exportToFile;
private:
	
	
  AgentMap ag;
	Scoli sc;

	double radius_moore;
	double r;
	

	double prag_satisfactie;
	int seed, pas_timp, pas_timp_bmp;
	
};