#include "StdAfx.h"
#include "utility.h"
#include <math.h>


utility::utility(void)
{
}


utility::~utility(void)
{
}


double utility::util_schel(const int tip_agent, const int agenti_albi, const int agenti_negri)
{
	// counting number of neigh
	int nr_agenti = agenti_albi + agenti_negri;
	
	if(nr_agenti ==0) return 1.;

	if (tip_agent == 1)  
	{
		if (agenti_albi <= fA * nr_agenti ) 
			return (agenti_albi / (fA* nr_agenti)) ;
		else 
			return MA + agenti_negri*(1-MA)/((1-fA)*nr_agenti);		
	}
	else if (tip_agent == -1) 
	{
		if (agenti_negri <= fB * nr_agenti ) 
			return (agenti_negri / (fB* nr_agenti)) ;
		else 
			return MB + agenti_albi*(1-MB)/((1-fB)*nr_agenti);		
	}
	
	else return -1;
}

double utility::util_dist(const double dist)
{
	if (dist_max < 1.e-6) 
		return 1.; 
	if (dist > dist_max) 
		return 0.;
	return (dist_max - dist)/dist_max;
}

double utility::util_m2(const int tip_agent, const int agenti_albi, const int agenti_negri, const double dist)
{
	double u1 = util_schel(tip_agent, agenti_albi, agenti_negri);
	double u2 = util_dist(dist);

	

	if (alpha < 0 || alpha >1) return -1;

	if ( abs(alpha)< 1.e-6)  return u2;
	if ( abs(alpha -1)< 1.e-6)  return u1;

	return pow(u1, alpha)*pow(u2, 1-alpha);

}

double utility::dist_tor( const int x1, const int y1, const int x2, const int y2, const int N)
{
	double d;
	double dx = N+1., dy= N+1.;
	for ( int ix =-1; ix<=1; ix++)
	{
		if ( abs (x2-x1 + 1.*ix * N ) < dx) dx = abs(x2-x1 + 1.*ix * N);
		if ( abs (y2-y1 + 1.*ix * N ) < dy) dy = abs(y2-y1 + 1.*ix * N );
	}
	d = sqrt(dx*dx+dy*dy);
	return d;
}
